// Fig. 10.13: Employee.java
// Superclasse abstrata Employee implementa Payable.

public abstract class Employee implements Payable
{
   private String firstName;
   private String lastName;
   private String socialSecurityNumber;

   // construtor com trs argumentos
   public Employee( String first, String last, String ssn )
   {
      firstName = first;
      lastName = last;
      socialSecurityNumber = ssn;
   } // fim do construtor Employee com trs argumentos

   // configura o nome 
   public void setFirstName( String first )
   {
      firstName = first;
   } // fim do mtodo setFirstName 

   // retorna o nome
   public String getFirstName()
   {
      return firstName;
   } // fim do mtodo getFirstName

   // configura o sobrenome 
   public void setLastName( String last )
   {
      lastName = last;
   } // fim do mtodo setLastName 

   // retorna o sobrenome
   public String getLastName()
   {
      return lastName;
   } // fim do mtodo getLastName

   // configura o CIC 
   public void setSocialSecurityNumber( String ssn )
   {
      socialSecurityNumber = ssn; // deve validar
   } // fim do mtodo setSocialSecurityNumber

   // retorna o CIC
   public String getSocialSecurityNumber()
   {
      return socialSecurityNumber;
   } // fim do mtodo getSocialSecurityNumber 

   // retorna a representao de String do objeto Employee
   public String toString()
   {
      return String.format( "%s %s\nsocial security number: %s", 
         getFirstName(), getLastName(), getSocialSecurityNumber() );
   } // fim do mtodo toString

   // Nota: No implementamos o mtodo getPaymentAmount de Payable aqui, assim ento
   // Essa classe deve ser declarada abstrata para evitar um erro de compilao.
} // fim da classe abstrata Employee 


/**************************************************************************
 * (C) Copyright 1992-2005 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/