// Fig. 10.12: Invoice.java
// Classe Invoice que implementa Payable.

public class Invoice implements Payable
{
   private String partNumber; 
   private String partDescription;
   private int quantity;
   private double pricePerItem;

   // construtor com quatro argumentos
   public Invoice( String part, String description, int count, 
      double price )
   {
      partNumber = part;
      partDescription = description;
      setQuantity( count ); // valida e armazena a quantidade
      setPricePerItem( price ); // valida e armazena o preo por item
   } // fim do construtor Invoice de quatro argumentos

   // configura nmero de peas
   public void setPartNumber( String part )
   {
      partNumber = part;  
   } // fim do mtodo setPartNumber

   // obtm o nmero da pea
   public String getPartNumber()
   {
      return partNumber;
   } // fim do mtodo getPartNumber

   // configura a descrio
   public void setPartDescription( String description )
   {
      partDescription = description;
   } // fim do mtodo setPartDescription

   // obtm a descrio
   public String getPartDescription()
   {
      return partDescription;
   } // fim do mtodo getPartDescription

   // configura a quantidade
   public void setQuantity( int count )
   {
      quantity = ( count < 0 ) ? 0 : count; // quantidade no pode ser negativa
   } // fim do mtodo setQuantity

   // obtm quantidade
   public int getQuantity()
   {
      return quantity;
   } // fim do mtodo getQuantity

   // configura preo por item
   public void setPricePerItem( double price )
   {
      pricePerItem = ( price < 0.0 ) ? 0.0 : price; // valida preo
   } // fim do mtodo setPricePerItem

   // obtm preo por item
   public double getPricePerItem()
   {
      return pricePerItem;
   } // fim do mtodo getPricePerItem

   // retorno da representao de String do objeto Invoice
   public String toString()
   {
      return String.format( "%s: \n%s: %s (%s) \n%s: %d \n%s: $%,.2f", 
         "invoice", "part number", getPartNumber(), getPartDescription(), 
         "quantity", getQuantity(), "price per item", getPricePerItem() );
   } // fim do mtodo toString

   // mtodo requerido para executar o contrato com a interface Payable     
   public double getPaymentAmount()                                    
   {                                                                   
      return getQuantity() * getPricePerItem(); // calcula custo total
   } // fim do mtodo getPaymentAmount                                    
} // fim da classe Invoice


/**************************************************************************
 * (C) Copyright 1992-2005 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/